//////////////////////////////////////////////////////////////////////////////////
int   push = 0, md = 11, area = 3, sz, ly, dst = 8, hdst = dst / 2;  // глобальные переменные 
float lev = 0, k1 = 0.05, k2 = 0.05, foff = 0.98, madd = 7, md1 = md - 1;
float[] value, speed;                                                // массивы

//////////////////////////////////////////////////////////////////////////////////
void setup()                                                          // функция начальных установок
{ 
  size(640, 320); cursor(CROSS); sz = width / dst; ly = height / 2; 
  smooth(); frameRate(25);                                            // все как обычно и 25 раз в секунду 
  value = new float[sz]; speed = new float[sz];                       // задание размеров массивов
  for (int i = 0; i < sz; i++) value[i] = speed[i] = 0;               // обнуление, для порядка
}

//////////////////////////////////////////////////////////////////////////////////
float herm (float t) { return t * t * (3 - 2 * t); }                  // функция эрмита

void falloff (int r, int g, int b, int a)                             // затухание экрана в цвет r, g, b и величиной a
{ 
  fill(255, 170, 0, 100); noStroke(); rect (0, 0, width, height);
}

//////////////////////////////////////////////////////////////////////////////////
void draw()                                                           // функция рисования, вызывается n - раз(кадров) в секунду
{   
  float v, x, y, y2, px = 0, py = 0, m, r, r2;
  int i, j, ix, i2;
  falloff(255, 170, 0, 75);                                          // затухание картинки в оранжевый
  for (i = 0; i < sz; i++)                                            // расчет взаимного влияния и приближения к общему уровню: 
  { speed[i] -= k1 * ((v = value[i]) - lev);                          // приближение к уровню
    for (j = 1; j <= area; j++)                                       // влияние соседей с глубиной просчета - area
    speed[i] += k2 * (value[max(i - j, 0)] + value[min(i + j, sz - 1)] - 2 * v) / j;
  };
  if (mousePressed)                                                   // расчет толчка кликом мыши
  { ix = (constrain (mouseX, 0, width - 1) - hdst) / dst; 
    if (mouseY > ly) m = madd; else m = - madd; 
    speed[ix] += m; 
    for (i = 1; i < md; i++)
    { i2 = ix - i; if (i2 >= 0) speed[i2] += m * herm((md1 - i) / md1);
      i2 = ix + i; if (i2 < sz) speed[i2] += m * herm((md1 - i) / md1);
    };
    fill(155, 55, 0); stroke(255, 255, 255); ellipse (mouseX, mouseY, 12, 12);
    if (push == 0) push = 8;
  }
  if (push != 0)                                                      // украшательства действия толчка
  { int p = 8 - push; noFill(); stroke(255, 255, 255, 15 + 240 - p * 25);
    r = 20 + p * p * p; ellipse (mouseX, mouseY, r, r); push--;
  }
  for (i = 0; i < sz; i++)                                            // сумма всех воздействий -> + к скорости, а ее + к уровням
  value[i] += speed[i] *= foff;
                                                                      // отрисовка
  fill(255, 255, 255); stroke (255, 255, 255);                        // визуализация скоростей 
  /*for (i = 0; i < sz; i++)                                            // через вектора
  { x = hdst + i * dst; y = ly - value[i]; r = 3;
    if (abs(speed[i]) > 1) { line (x, y, x, y2 = y - speed[i] * 1.5); ellipse (x, y2, 2, 2); };
  }/**/  
  for (i = 0; i < sz; i++)                                            // через квадраты скоростей и кружочки
  { r = sq(speed[i]) * 0.5; stroke (225, 125, 0); noFill(); ellipse (hdst + i * dst, ly - value[i], r, r);
  }/**/
  for (i = 0; i < sz; i++)                                            // через кружочки
  { r = abs(speed[i]) * 3; stroke (255, 255, 255); noFill(); ellipse (hdst + i * dst, ly - value[i], r, r);
  }/**/
  stroke (50, 70, 30);
  for (i = 0; i < sz; i++)                                            // визуализация уровня линиями
  { x = hdst + i * dst; y = ly - value[i];
    if (i != 0) line(px, py, x, y); px = x; py = y;
  }
  noStroke ();  
  for (i = 0; i < sz; i++)                                            // визуализация уровня кружочками
  { r = 2.5;  x = hdst + i * dst + 0.5; y = ly - value[i] + 0.5;                                       
    r += abs(speed[i]) * 0.175;                                       // визуализация абс. значения скорости через размер
    fill(50, 70, 30); ellipse (x, y, r + 1.75, r + 1.75);
    fill(255, 225, 155); ellipse (x, y, r, r);
  };
}
